package com.dcsoft.system.controller;

import cn.hutool.core.util.ObjectUtil;
import cn.hutool.http.HttpUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.dcsoft.common.core.constant.CacheConstants;
import com.dcsoft.common.core.domain.R;
import com.dcsoft.common.core.exception.ServiceException;
import com.dcsoft.common.core.utils.SpringUtils;
import com.dcsoft.common.core.utils.StringUtils;
import com.dcsoft.common.core.utils.poi.ExcelUtil;
import com.dcsoft.common.core.web.controller.BaseController;
import com.dcsoft.common.core.web.domain.AjaxResult;
import com.dcsoft.common.core.web.page.TableDataInfo;
import com.dcsoft.common.log.annotation.Log;
import com.dcsoft.common.log.enums.BusinessType;
import com.dcsoft.common.redis.service.RedisService;
import com.dcsoft.common.security.annotation.InnerAuth;
import com.dcsoft.common.security.annotation.RequiresPermissions;
import com.dcsoft.common.security.utils.SecurityUtils;
import com.dcsoft.common.sms.config.properties.SmsProperties;
import com.dcsoft.common.sms.entity.SmsResult;
import com.dcsoft.common.sms.service.SmsTemplate;
import com.dcsoft.system.api.domain.SmsDTO;
import com.dcsoft.system.api.domain.SysDept;
import com.dcsoft.system.api.domain.SysRole;
import com.dcsoft.system.api.domain.SysUser;
import com.dcsoft.system.api.model.LoginUser;
import com.dcsoft.system.domain.vo.AppletInfoVo;
import com.dcsoft.system.service.*;
import com.dcsoft.system.uniubi.service.ISysApiService;
import com.dcsoft.system.utils.WeChatUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.ArrayUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.concurrent.TimeUnit;
import java.util.stream.Collectors;

/**
 * 用户信息
 *
 * @author dcsoft
 */
@Slf4j
@RestController
@RequestMapping("/user")
public class SysUserController extends BaseController
{
    @Autowired
    private ISysUserService userService;

    @Autowired
    private ISysRoleService roleService;

    @Autowired
    private ISysDeptService deptService;

    @Autowired
    private ISysPostService postService;

    @Autowired
    private ISysPermissionService permissionService;

    @Autowired
    private ISysConfigService configService;

    @Autowired
    private SmsProperties smsProperties;

    @Autowired
    private RedisService redisService;

    @Value("${applet.appid}")
    public String appid;

    @Value("${applet.secret}")
    public String secret;

    @Value("${weixin.token}")
    public String weixinToken;

    /**
     * 获取用户列表
     */
//    @RequiresPermissions("system:user:list")
    @GetMapping("/list")
    public TableDataInfo list(SysUser user)
    {
        startPage();
        List<SysUser> list = userService.selectUserList(user);
        return getDataTable(list);
    }

    @Log(title = "用户管理", businessType = BusinessType.EXPORT)
    @RequiresPermissions("system:user:export")
    @PostMapping("/export")
    public void export(HttpServletResponse response, SysUser user)
    {
        List<SysUser> list = userService.selectUserList(user);
        ExcelUtil<SysUser> util = new ExcelUtil<SysUser>(SysUser.class);
        util.exportExcel(response, list, "用户数据");
    }

    @Log(title = "用户管理", businessType = BusinessType.IMPORT)
    @RequiresPermissions("system:user:import")
    @PostMapping("/importData")
    public AjaxResult importData(MultipartFile file, boolean updateSupport) throws Exception
    {
        ExcelUtil<SysUser> util = new ExcelUtil<SysUser>(SysUser.class);
        List<SysUser> userList = util.importExcel(file.getInputStream());
        String operName = SecurityUtils.getUsername();
        String message = userService.importUser(userList, updateSupport, operName);
        return success(message);
    }

    @PostMapping("/importTemplate")
    public void importTemplate(HttpServletResponse response) throws IOException
    {
        ExcelUtil<SysUser> util = new ExcelUtil<SysUser>(SysUser.class);
        util.importTemplateExcel(response, "用户数据");
    }

    /**
     * 获取当前用户信息
     */
    @InnerAuth
    @GetMapping("/info/{username}")
    public R<LoginUser> info(@PathVariable("username") String username)
    {
        SysUser sysUser = userService.selectUserByUserName(username);
        if (StringUtils.isNull(sysUser))
        {
            return R.fail("用户名或密码错误");
        }
        // 角色集合
        Set<String> roles = permissionService.getRolePermission(sysUser);
        // 权限集合
        Set<String> permissions = permissionService.getMenuPermission(sysUser);
        LoginUser sysUserVo = new LoginUser();
        sysUserVo.setUserid(sysUser.getUserId());
        sysUserVo.setSysUser(sysUser);
        sysUserVo.setRoles(roles);
        sysUserVo.setPermissions(permissions);
        return R.ok(sysUserVo);
    }

    /**
     * 获取当前用户信息(不返回异常信息)
     */
    @InnerAuth
    @GetMapping("/infos/{username}")
    public R<LoginUser> infos(@PathVariable("username") String username)
    {
        SysUser sysUser = userService.selectUserByUserName(username);
        if (StringUtils.isNull(sysUser))
        {
            return R.ok();
        }
        // 角色集合
        Set<String> roles = permissionService.getRolePermission(sysUser);
        // 权限集合
        Set<String> permissions = permissionService.getMenuPermission(sysUser);
        LoginUser sysUserVo = new LoginUser();
        sysUserVo.setUserid(sysUser.getUserId());
        sysUserVo.setSysUser(sysUser);
        sysUserVo.setRoles(roles);
        sysUserVo.setPermissions(permissions);
        return R.ok(sysUserVo);
    }

    /**
     * 获取当前用户信息
     */
    @InnerAuth
    @GetMapping("/wxinfo/{openid}")
    public R<LoginUser> getWxUserInfo(@PathVariable("openid") String openid)
    {
        SysUser sysUser = userService.selectUserByOpenId(openid);
        if (StringUtils.isNull(sysUser))
        {
            return R.fail(10001, "用户名或密码错误");
        }
        // 角色集合
        Set<String> roles = permissionService.getRolePermission(sysUser);
        // 权限集合
        Set<String> permissions = permissionService.getMenuPermission(sysUser);
        LoginUser sysUserVo = new LoginUser();
        sysUserVo.setSysUser(sysUser);
        sysUserVo.setRoles(roles);
        sysUserVo.setPermissions(permissions);
        return R.ok(sysUserVo);
    }

    /**
     * 获取当前用户信息
     */
    @InnerAuth
    @PostMapping("/updateByUserId")
    public R<?> updateByUserId(@RequestBody SysUser user)
    {
        if (StringUtils.isNotEmpty(user.getPhonenumber()) && !userService.checkPhoneUnique(user))
        {
            throw new ServiceException(user.getUserName() + "手机号码已存在");
        }
        userService.updateUserProfile(user);
        return R.ok();
    }

    /**
     * 注册用户信息
     */
    @InnerAuth
    @PostMapping("/updateOpenId")
    public R<Boolean> updateOpenId(@RequestBody SysUser sysUser)
    {
        System.out.println("SysUser==========="+sysUser.toString());
        if (userService.updateOpenId(sysUser)==0)
        {
            return R.fail("保存用户openid" + sysUser.getUserName() + "'失败，账号不存在");
        }
        return R.ok(true);
    }

    /**
     * 注册用户信息
     */
    @InnerAuth
    @PostMapping("/register")
    public R<Boolean> register(@RequestBody SysUser sysUser)
    {
        String username = sysUser.getUserName();
        if (!("true".equals(configService.selectConfigByKey("sys.account.registerUser"))))
        {
            return R.fail("当前系统没有开启注册功能！");
        }
        if (!userService.checkUserNameUnique(sysUser))
        {
            return R.fail("保存用户'" + username + "'失败，注册账号已存在");
        }
        return R.ok(userService.registerUser(sysUser));
    }

    /**
     * 获取用户信息
     *
     * @return 用户信息
     */
    @GetMapping("getInfo")
    public AjaxResult getInfo()
    {
        SysUser user = userService.selectUserById(SecurityUtils.getUserId());
        // 角色集合
        Set<String> roles = permissionService.getRolePermission(user);
        // 权限集合
        Set<String> permissions = permissionService.getMenuPermission(user);
        AjaxResult ajax = AjaxResult.success();
        ajax.put("user", user);
        ajax.put("roles", roles);
        ajax.put("permissions", permissions);
        return ajax;
    }

    /**
     * 根据用户编号获取详细信息
     */
    @RequiresPermissions("system:user:query")
    @GetMapping(value = { "/", "/{userId}" })
    public AjaxResult getInfo(@PathVariable(value = "userId", required = false) Long userId)
    {
        userService.checkUserDataScope(userId);
        AjaxResult ajax = AjaxResult.success();
        List<SysRole> roles = roleService.selectRoleAll();
        ajax.put("roles", SysUser.isAdmin(userId) ? roles : roles.stream().filter(r -> !r.isAdmin()).collect(Collectors.toList()));
        ajax.put("posts", postService.selectPostAll());
        if (StringUtils.isNotNull(userId))
        {
            SysUser sysUser = userService.selectUserById(userId);
            ajax.put(AjaxResult.DATA_TAG, sysUser);
            ajax.put("postIds", postService.selectPostListByUserId(userId));
            ajax.put("roleIds", sysUser.getRoles().stream().map(SysRole::getRoleId).collect(Collectors.toList()));
        }
        return ajax;
    }

    /**
     * 新增用户
     */
    @RequiresPermissions("system:user:add")
    @Log(title = "用户管理", businessType = BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@Validated @RequestBody SysUser user)
    {
        if (!userService.checkUserNameUnique(user))
        {
            return error("新增用户'" + user.getUserName() + "'失败，登录账号已存在");
        }
        else if (StringUtils.isNotEmpty(user.getPhonenumber()) && !userService.checkPhoneUnique(user))
        {
            return error("新增用户'" + user.getUserName() + "'失败，手机号码已存在");
        }
        else if (StringUtils.isNotEmpty(user.getEmail()) && !userService.checkEmailUnique(user))
        {
            return error("新增用户'" + user.getUserName() + "'失败，邮箱账号已存在");
        }
        user.setCreateBy(SecurityUtils.getUsername());
        user.setPassword(SecurityUtils.encryptPassword(user.getPassword()));
        int i=userService.insertUser(user);
        /*try {
            SysBranch sysBranch =sysBranchService.selectSysBranchByDeptId(user.getDeptId());
            if(sysBranch!=null){//查询到部门绑定的人员时
                SysPeople people=new SysPeople();
                people.setUserId(user.getUserId());
                people.setName(user.getUserName());
                people.setPhone(user.getPhonenumber());
                people.setSex(user.getSex());
                people.setBranchId(sysBranch.getId());
                String data=sysApiService.admitCreate(people);
                JSONObject json= JSONObject.parseObject(data);
                if("1".equals(json.get("result")+"")){
                    JSONObject obj= (JSONObject) json.get("data");
                    String admitGuid=obj.get("admitGuid")+"";
                    people.setGuid(admitGuid);
                }
                peopleService.insertSysPeople(people);
            }
        }catch (Exception e){
            e.printStackTrace();
        }*/
        return toAjax(i);
    }

    /**
     * 修改用户
     */
    @RequiresPermissions("system:user:edit")
    @Log(title = "用户管理", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@Validated @RequestBody SysUser user)
    {
        userService.checkUserAllowed(user);
        userService.checkUserDataScope(user.getUserId());
        if (!userService.checkUserNameUnique(user))
        {
            return error("修改用户'" + user.getUserName() + "'失败，登录账号已存在");
        }
        else if (StringUtils.isNotEmpty(user.getPhonenumber()) && !userService.checkPhoneUnique(user))
        {
            return error("修改用户'" + user.getUserName() + "'失败，手机号码已存在");
        }
        else if (StringUtils.isNotEmpty(user.getEmail()) && !userService.checkEmailUnique(user))
        {
            return error("修改用户'" + user.getUserName() + "'失败，邮箱账号已存在");
        }
        user.setUpdateBy(SecurityUtils.getUsername());
        return toAjax(userService.updateUser(user));
    }

    /**
     * 删除用户
     */
    @RequiresPermissions("system:user:remove")
    @Log(title = "用户管理", businessType = BusinessType.DELETE)
    @DeleteMapping("/{userIds}")
    public AjaxResult remove(@PathVariable Long[] userIds)
    {
        if (ArrayUtils.contains(userIds, SecurityUtils.getUserId()))
        {
            return error("当前用户不能删除");
        }
        return toAjax(userService.deleteUserByIds(userIds));
    }

    /**
     * 重置密码
     */
    @RequiresPermissions("system:user:edit")
    @Log(title = "用户管理", businessType = BusinessType.UPDATE)
    @PutMapping("/resetPwd")
    public AjaxResult resetPwd(@RequestBody SysUser user)
    {
        userService.checkUserAllowed(user);
        userService.checkUserDataScope(user.getUserId());
        user.setPassword(SecurityUtils.encryptPassword(user.getPassword()));
        user.setUpdateBy(SecurityUtils.getUsername());
        return toAjax(userService.resetPwd(user));
    }

    /**
     * 状态修改
     */
    @RequiresPermissions("system:user:edit")
    @Log(title = "用户管理", businessType = BusinessType.UPDATE)
    @PutMapping("/changeStatus")
    public AjaxResult changeStatus(@RequestBody SysUser user)
    {
        userService.checkUserAllowed(user);
        userService.checkUserDataScope(user.getUserId());
        user.setUpdateBy(SecurityUtils.getUsername());
        return toAjax(userService.updateUserStatus(user));
    }

    /**
     * 根据用户编号获取授权角色
     */
    @RequiresPermissions("system:user:query")
    @GetMapping("/authRole/{userId}")
    public AjaxResult authRole(@PathVariable("userId") Long userId)
    {
        AjaxResult ajax = AjaxResult.success();
        SysUser user = userService.selectUserById(userId);
        List<SysRole> roles = roleService.selectRolesByUserId(userId);
        ajax.put("user", user);
        ajax.put("roles", SysUser.isAdmin(userId) ? roles : roles.stream().filter(r -> !r.isAdmin()).collect(Collectors.toList()));
        return ajax;
    }

    /**
     * 用户授权角色
     */
    @RequiresPermissions("system:user:edit")
    @Log(title = "用户管理", businessType = BusinessType.GRANT)
    @PutMapping("/authRole")
    public AjaxResult insertAuthRole(Long userId, Long[] roleIds)
    {
        userService.checkUserDataScope(userId);
        userService.insertUserAuth(userId, roleIds);
        return success();
    }

    /**
     * 获取部门树列表
     */
//    @RequiresPermissions("system:user:list")
    @GetMapping("/deptTree")
    public AjaxResult deptTree(SysDept dept)
    {
        return success(deptService.selectDeptTreeList(dept));
    }

    /**
     * 获取小程序openid和session_key
     * @param code
     * @return
     */
    @GetMapping("/jscode2session")
    public AjaxResult jscode2session(String code) {
        String url = "https://api.weixin.qq.com/sns/jscode2session?appid="+ appid +"&secret="+ secret +"&js_code="+ code +"&grant_type=authorization_code";
        String body = HttpUtil.createGet(url).execute().body();
        if(body.contains("errcode")){
            return AjaxResult.error(body);
        }
        JSONObject jsonObject = JSON.parseObject(body);
        return AjaxResult.success(jsonObject);
    }

    /**
     * 根据code获取手机号
     *
     * @param json
     * @return
     */
    @PostMapping("/getuserphonenumber")
    public AjaxResult getuserphonenumber(@RequestBody JSONObject json) {
        if (ObjectUtil.isNull(json) || StringUtils.isBlank(json.getString("code"))) {
            throw new ServiceException("参数code不能为空");
        }
        String code = json.getString("code");
        Map<String, Object> map = new HashMap<>();
        map.put("code", code);
        log.info("getuserphonenumber入参：{}", code);
        String wxToken = getWxToken();
        log.info("getuserphonenumber_getWxToken：{}", wxToken);
        String url = "https://api.weixin.qq.com/wxa/business/getuserphonenumber?access_token= " + wxToken;
        String body = HttpUtil.createPost(url).body(JSON.toJSONString(map)).execute().body();
        log.info("getuserphonenumber_result:{}", body);
        JSONObject jsonObject = JSON.parseObject(body);
        if (jsonObject.getInteger("errcode") != 0) {
            return AjaxResult.error(body);
        }
        return AjaxResult.success(jsonObject);
    }


    /**
     * 获取小程序token
     * @return
     */
    private String getWxToken() {
        String cacheObject = redisService.getCacheObject(CacheConstants.WEIXIN_TOKEN);
        if (org.apache.commons.lang3.StringUtils.isNotEmpty(cacheObject)) {
            return cacheObject;
        }
        String body = HttpUtil.createGet(weixinToken).execute().body();
        JSONObject object = JSONObject.parseObject(body);
        String string = object.get("access_token").toString();
        redisService.setCacheObject(CacheConstants.LOGIN_TOKEN, string, Long.valueOf(object.get("expires_in").toString()), TimeUnit.SECONDS);
        return string;
    }

    /**
     * 小程序获取token
     * @param appletInfoVo
     * @return
     */
    @PostMapping("/queryAppletToken")
    public AjaxResult queryAppletToken(AppletInfoVo appletInfoVo) {
        return success(userService.queryAppletToken(appletInfoVo));
    }

    /**
     * 小程序修改用户头像
     * @return
     */
    @PostMapping("/updateAppletAvatar")
    public AjaxResult updateAppletAvatar(@RequestParam("avatarfile") MultipartFile file, @RequestParam("userName") String userName) {
        return success(userService.updateAppletAvatar(file, userName));
    }

    /**
     * 发送消息
     * @return
     */
    @PostMapping("/sendMessage")
    public AjaxResult sendMessage(@RequestBody SmsDTO sms) {
        if (StringUtils.isEmpty(sms.getPhone())) {
            return error("手机号不能为空!");
        }
        if (!smsProperties.getEnabled()) {
            error("当前系统没有开启短信功能！");
        }
        Map<String, String> map = new HashMap<>();
        if(StringUtils.isNotBlank(sms.getCode())) {
            map.put("code", sms.getCode());
        }
        if(StringUtils.isNotBlank(sms.getCaptcha())) {
            map.put("captcha", sms.getCaptcha());
        }
        SmsTemplate smsTemplate = SpringUtils.getBean(SmsTemplate.class);
        SmsResult result = smsTemplate.send(sms.getPhone(), sms.getTemplateId(), map);
        if (!result.getIsSuccess()) {
            return error(result.getMessage());
        }
        return AjaxResult.success();
    }


}
